# My answer

# Arrange the data ----

# Read in the dataframes
pa <- read.csv("data/NAPresAbsMatrix.csv", header=T)
traits <- read.csv("data/NA_AllMammals_AllTraits.csv", header=T)
clim <- read.csv("data/BioclimVariables.csv", header=T)

# clean trait data and pull out traits of interest
traits$TaxonName <- gsub(" ", "_", traits$TaxonName)

which.trait <- c(2,30,1,12,25,16,17,5,22,27,9,26)+1
traits_trim <- traits[,which.trait]
rownames(traits_trim) <- traits$TaxonName

# trim down the pa matrix
pa_trim <- pa[,-c(1:3)]
rownames(pa_trim) <- pa$GlobalID

# calc Ecometric Mean
source("calcEcometricMean_df.R")
x <- calcEcometricMean_df(pa_trim, traits_trim)

# generate a null distribution of ecoMetric mean ----
  # first, do this for all values of species richness, then generate the location specific values
  nullRich <- seq(min(nSpecies_v), max(nSpecies_v), by=1)
  R <- 1000
  species <- rownames(traits_trim)
  null_df <- matrix(0, nrow=R, ncol=length(nullRich))

ecoMeanFcn <- function(nullRich, species, traits_trim){              
  ecoMean <- matrix(0, nrow=length(nullRich), ncol=ncol(traits_trim))
  for (i in 1:length(nullRich)){
   tax <- sample(species, size=nullRich[i], replace=F)  
   traits_df <- traits_trim[match(tax, rownames(traits_trim)),]
   ecoMean[i,] <- colMeans(traits_df, na.rm=T)
  }
  return(ecoMean)
}

nullResults <- replicate(R, ecoMeanFcn(nullRich, species, traits_trim), simplify = F)
nullMean <- apply(simplify2array(nullResults), c(1,2), mean, na.rm=T) 
nullSD <- apply(simplify2array(nullResults), c(1,2), sd, na.rm=T)
rownames(nullMean) <- rownames(nullSD) <- nullRich
colnames(nullMean) <- colnames(nullSD) <- colnames(traits_trim)

# now correct the empirical mean by the null mean for each location ----
anom_df <- matrix(NA, nrow=nrow(ecoMean_df), ncol=ncol(ecoMean_df))
for (i in 1:length(nSpecies_v)){
  n <- nSpecies_v[i]
  nullRow <- match(n, rownames(nullMean))
  anom_df[i,] <- ecoMean_df[i,] - nullMean[nullRow,]
}
colnames(anom_df) <- colnames(ecoMean_df)
rownames(anom_df) <- rownames(ecoMean_df)

# Correlate with temperature ----





# Not run : trying to count missing data for each trait and cell, but not necessary here
n_missingValues <-  
  ecoDF_n1 <- ecoDF[which(nSpecies == 1)]  
if (nSpecies == 1){
  n_missingValues[1,] <- 
}
n_missingValues <-  lapply(ecoDF, function(x) colSums(is.na(ecoDF)) )

